package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;


/**
 * 实体[UserObject] 数据对象
 */
@TableName(value = "T_SRFUSEROBJECT",resultMap = "UserObjectResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class UserObject extends EntityBase implements Serializable{

    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    @Dict(dictName = "ionicdemo_YesNoCodeList")
    @TableLogic(value= "1",delval="0")//设定逻辑有效属性
    @TableField(fill = FieldFill.INSERT)
    private Integer enable;
    private String memo;
    private String ownerid;
    private String ownertype;
    private String subtype;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    private String userdata;
    private String userdata2;
    @TableId(value= "userobjectid",type=IdType.UUID)//指定主键生成策略
    private String userobjectid;
    private Integer userobjectlevel;
    private String userobjectname;
    @Dict(dictName = "ionicdemo_CodeList5CodeList")
    private String userobjecttype;
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[逻辑有效标志]
     *  @param enable
     */
    public void setEnable(Integer enable){
        this.enable = enable;
        this.set("enabledirtyflag",true);
    }
    /**
     *  获取属性值[逻辑有效标志]
     */
    public Integer getEnable(){
        if(StringUtils.isEmpty(enable))
        {
            this.enable = 1;//设置逻辑有效值
            this.set("enabledirtyflag",true);
        }
        return this.enable;
    }
    /**
     *  重置属性值[逻辑有效标志]
     */
    public void resetEnable(){
        this.set("enabledirtyflag",false);
        this.enable = null;
    }
    /**
     *  设置属性值[备注]
     *  @param memo
     */
    public void setMemo(String memo){
        if(StringUtils.isEmpty(memo))
            memo=null;
        this.memo = memo;
        this.set("memodirtyflag",true);
    }
    /**
     *  获取属性值[备注]
     */
    public String getMemo(){
        return this.memo;
    }
    /**
     *  重置属性值[备注]
     */
    public void resetMemo(){
        this.set("memodirtyflag",false);
        this.memo = null;
    }
    /**
     *  设置属性值[所有者标识]
     *  @param ownerid
     */
    public void setOwnerid(String ownerid){
        if(StringUtils.isEmpty(ownerid))
            ownerid=null;
        this.ownerid = ownerid;
        this.set("owneriddirtyflag",true);
    }
    /**
     *  获取属性值[所有者标识]
     */
    public String getOwnerid(){
        return this.ownerid;
    }
    /**
     *  重置属性值[所有者标识]
     */
    public void resetOwnerid(){
        this.set("owneriddirtyflag",false);
        this.ownerid = null;
    }
    /**
     *  设置属性值[所有者类型]
     *  @param ownertype
     */
    public void setOwnertype(String ownertype){
        if(StringUtils.isEmpty(ownertype))
            ownertype=null;
        this.ownertype = ownertype;
        this.set("ownertypedirtyflag",true);
    }
    /**
     *  获取属性值[所有者类型]
     */
    public String getOwnertype(){
        return this.ownertype;
    }
    /**
     *  重置属性值[所有者类型]
     */
    public void resetOwnertype(){
        this.set("ownertypedirtyflag",false);
        this.ownertype = null;
    }
    /**
     *  设置属性值[子类型]
     *  @param subtype
     */
    public void setSubtype(String subtype){
        if(StringUtils.isEmpty(subtype))
            subtype=null;
        this.subtype = subtype;
        this.set("subtypedirtyflag",true);
    }
    /**
     *  获取属性值[子类型]
     */
    public String getSubtype(){
        return this.subtype;
    }
    /**
     *  重置属性值[子类型]
     */
    public void resetSubtype(){
        this.set("subtypedirtyflag",false);
        this.subtype = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
    /**
     *  设置属性值[自定义数据]
     *  @param userdata
     */
    public void setUserdata(String userdata){
        if(StringUtils.isEmpty(userdata))
            userdata=null;
        this.userdata = userdata;
        this.set("userdatadirtyflag",true);
    }
    /**
     *  获取属性值[自定义数据]
     */
    public String getUserdata(){
        return this.userdata;
    }
    /**
     *  重置属性值[自定义数据]
     */
    public void resetUserdata(){
        this.set("userdatadirtyflag",false);
        this.userdata = null;
    }
    /**
     *  设置属性值[自定义数据2]
     *  @param userdata2
     */
    public void setUserdata2(String userdata2){
        if(StringUtils.isEmpty(userdata2))
            userdata2=null;
        this.userdata2 = userdata2;
        this.set("userdata2dirtyflag",true);
    }
    /**
     *  获取属性值[自定义数据2]
     */
    public String getUserdata2(){
        return this.userdata2;
    }
    /**
     *  重置属性值[自定义数据2]
     */
    public void resetUserdata2(){
        this.set("userdata2dirtyflag",false);
        this.userdata2 = null;
    }
    /**
     *  设置属性值[用户对象标识]
     *  @param userobjectid
     */
    public void setUserobjectid(String userobjectid){
        if(StringUtils.isEmpty(userobjectid))
            userobjectid=null;
        this.userobjectid = userobjectid;
        this.set("userobjectiddirtyflag",true);
    }
    /**
     *  获取属性值[用户对象标识]
     */
    public String getUserobjectid(){
        return this.userobjectid;
    }
    /**
     *  重置属性值[用户对象标识]
     */
    public void resetUserobjectid(){
        this.set("userobjectiddirtyflag",false);
        this.userobjectid = null;
    }
    /**
     *  设置属性值[用户对象级别]
     *  @param userobjectlevel
     */
    public void setUserobjectlevel(Integer userobjectlevel){
        this.userobjectlevel = userobjectlevel;
        this.set("userobjectleveldirtyflag",true);
    }
    /**
     *  获取属性值[用户对象级别]
     */
    public Integer getUserobjectlevel(){
        return this.userobjectlevel;
    }
    /**
     *  重置属性值[用户对象级别]
     */
    public void resetUserobjectlevel(){
        this.set("userobjectleveldirtyflag",false);
        this.userobjectlevel = null;
    }
    /**
     *  设置属性值[用户对象名称]
     *  @param userobjectname
     */
    public void setUserobjectname(String userobjectname){
        if(StringUtils.isEmpty(userobjectname))
            userobjectname=null;
        this.userobjectname = userobjectname;
        this.set("userobjectnamedirtyflag",true);
    }
    /**
     *  获取属性值[用户对象名称]
     */
    public String getUserobjectname(){
        return this.userobjectname;
    }
    /**
     *  重置属性值[用户对象名称]
     */
    public void resetUserobjectname(){
        this.set("userobjectnamedirtyflag",false);
        this.userobjectname = null;
    }
    /**
     *  设置属性值[用户对象类型]
     *  @param userobjecttype
     */
    public void setUserobjecttype(String userobjecttype){
        if(StringUtils.isEmpty(userobjecttype))
            userobjecttype=null;
        this.userobjecttype = userobjecttype;
        this.set("userobjecttypedirtyflag",true);
    }
    /**
     *  获取属性值[用户对象类型]
     */
    public String getUserobjecttype(){
        return this.userobjecttype;
    }
    /**
     *  重置属性值[用户对象类型]
     */
    public void resetUserobjecttype(){
        this.set("userobjecttypedirtyflag",false);
        this.userobjecttype = null;
    }
    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetCreatedate();
        resetCreateman();
        resetEnable();
        resetMemo();
        resetOwnerid();
        resetOwnertype();
        resetSubtype();
        resetUpdatedate();
        resetUpdateman();
        resetUserdata();
        resetUserdata2();
        resetUserobjectid();
        resetUserobjectlevel();
        resetUserobjectname();
        resetUserobjecttype();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public UserObject copyTo(UserObject targetEntity)
	{
		BeanCopier copier=BeanCopier.create(UserObject.class, UserObject.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetUserobjectid();
		return targetEntity;
	}
}